diff -ru hurd-0.0/hurd/diskfs.h hurd-0.1/hurd/diskfs.h
--- hurd-0.0/hurd/diskfs.h	Mon Jul 15 22:35:45 1996
+++ hurd-0.1/hurd/diskfs.h	Thu Sep  5 11:16:56 1996
@@ -203,11 +203,13 @@
    filesystem server. */
 extern char *diskfs_server_name;
 
-/* The user must define these variables.  Set these to be the major, minor,
-   and edit version numbers.  */
-extern int diskfs_major_version;
-extern int diskfs_minor_version;
-extern int diskfs_edit_version;
+/* The user must define this variables.  Set this to be the server
+   version number.  */
+extern char *diskfs_server_version;
+
+/* The user may define this variable.  Set this to be any additional
+   version specification that should be printed for --version. */
+extern char *diskfs_extra_version;
 
 /* The user may define this variable.  This should be nonzero iff the
    filesystem format supports shortcutting symlink translation.
@@ -364,7 +366,7 @@
    metadata.  If CLEAN is nonzero, then after this is written the
    filesystem will be absolutely clean, and the non-paged metadata can
    so indicate.  */
-void diskfs_set_hypermetadata (int wait, int clean);
+error_t diskfs_set_hypermetadata (int wait, int clean);
 
 /* The user must define this function.  Allocate a new node to be of
    mode MODE in locked directory DP (don't actually set the mode or
diff -ru hurd-0.0/hurd/ports.h hurd-0.1/hurd/ports.h
--- hurd-0.0/hurd/ports.h	Mon May  6 16:34:34 1996
+++ hurd-0.1/hurd/ports.h	Wed Aug  7 15:28:35 1996
@@ -162,6 +162,18 @@
 			   struct port_bucket *bucket,
 			   size_t size,
 			   void *result);
+
+/* Just like ports_create_port, except don't actually put the port
+   into the portset underlying BUCKET.  This is intended to be used
+   for cases where the port right must be given out before the port is
+   fully initialized; with this call you are guaranteed that no RPC
+   service will occur on the port until you have finished initializing
+   it and installed it into the portset yourself. */
+error_t
+ports_create_port_noinstall (struct port_class *class,
+			     struct port_bucket *bucket,
+			     size_t size,
+			     void *result);
    
 /* For an existing RECEIVE right, create and return in RESULT a new port
    structure; BUCKET, SIZE, and CLASS args are as for ports_create_port. */
@@ -376,5 +388,7 @@
 #define _PORTS_BLOCKED		PORTS_BLOCKED
 #define _PORTS_INHIBIT_WAIT	PORTS_INHIBIT_WAIT
 void _ports_complete_deallocate (struct port_info *);
+error_t _ports_create_port_internal (struct port_class *, struct port_bucket *,
+				     size_t, void *, int);
 
 #endif
diff -ru hurd-0.0/hurd/store.h hurd-0.1/hurd/store.h
--- hurd-0.0/hurd/store.h	Tue May 21 19:58:28 1996
+++ hurd-0.1/hurd/store.h	Thu Sep  5 10:12:37 1996
@@ -68,9 +68,9 @@
   size_t size;
 
   /* Log_2 (BLOCK_SIZE) or 0 if not a power of 2. */
-  int log2_block_size;
+  unsigned log2_block_size;
   /* Log_2 (VM_PAGE_SIZE / BLOCK_SIZE); only valid if LOG2_BLOCK_SIZE is.  */
-  int log2_blocks_per_page;
+  unsigned log2_blocks_per_page;
 
   /* Random flags.  */
   int flags;
@@ -91,15 +91,18 @@
    <hurd/hurd_types.h>.  XXX synchronize these values.  */
 
 /* Flags that reflect something immutable about the object.  */
-#define STORE_IMMUTABLE_FLAGS	0xFF
+#define STORE_IMMUTABLE_FLAGS	0x00FF
 
 /* Flags implemented by generic store code.  */
-#define STORE_READONLY		0x100	/* No writing allowed. */
-#define STORE_GENERIC_FLAGS	STORE_READONLY
+#define STORE_READONLY		0x0100	/* No writing allowed. */
+#define STORE_NO_FILEIO		0x0200	/* If store_create can't fetch store
+					   information, don't create a store
+					   using file io instead.  */
+#define STORE_GENERIC_FLAGS	(STORE_READONLY | STORE_NO_FILEIO)
 
 /* Flags implemented by each backend.  */
-#define STORE_HARD_READONLY	0x200	/* Can't be made writable.  */
-#define STORE_ENFORCED		0x400	/* Range is enforced by device.  */
+#define STORE_HARD_READONLY	0x0400	/* Can't be made writable.  */
+#define STORE_ENFORCED		0x0800	/* Range is enforced by device.  */
 #define STORE_BACKEND_SPEC_BASE	0x1000 /* Here up are backend-specific */
 #define STORE_BACKEND_FLAGS	(STORE_HARD_READONLY | STORE_ENFORCED \
 				 | ~(STORE_BACKEND_SPEC_BASE - 1))
@@ -169,6 +172,14 @@
 
 void store_free (struct store *store);
 
+/* Open the file NAME, and return a new store in STORE, which refers to the
+   storage underlying it.  CLASSES is used to select classes specified by the
+   provider; if it is 0, STORE_STD_CLASSES is used.  FLAGS is set with
+   store_set_flags.  A reference to the open file is created (but may be
+   destroyed with store_close_source).  */
+error_t store_open (char *name, int flags, struct store_class *classes,
+		    struct store **store);
+
 /* Allocate a new store structure with class CLASS, and the various other
    fields initialized to the given parameters.  */
 struct store *
@@ -392,22 +403,24 @@
 
 /* An argument parser that may be used for parsing a simple command line
    specification for stores.  The accompanying input parameter must be a
-   pointer to a structure of type struct store_argp_param.  */
+   pointer to a location in which to store the resulting pointer to a struct
+   store_parsed.  */
 extern struct argp store_argp;
 
-/* Structure used to pass in arguments and return the result from
-   STORE_ARGP.  */
-struct store_argp_params
-{
-  /* An initial set of flags desired to be set.  */
-  int flags;
-
-  /* If true, don't attempt use store_file_create to create a store on files
-     upon which store_create has failed.  */
-  int no_file_io : 1;
-
-  /* Parsed store returned here.  */
-  struct store *result;
-};
+/* The result of parsing a store, which should be enough information to open
+   it, or return the arguments.  */
+struct store_parsed;
+
+/* Free all resources used by PARSED.  */
+void store_parsed_free (struct store_parsed *parsed);
+
+/* Open PARSED, and return the corresponding store in STORE.  */
+error_t store_parsed_open (const struct store_parsed *parsed, int flags,
+			   struct store_class *classes,
+			   struct store **store);
+
+/* Add the arguments  PARSED, and return the corresponding store in STORE.  */
+error_t store_parsed_append_args (const struct store_parsed *parsed,
+				  char **args, size_t *args_len);
 
 #endif /* __STORE_H__ */
Only in hurd-0.0/hurd: version.h
diff -ru hurd-0.0/include/argp.h hurd-0.1/include/argp.h
--- hurd-0.0/include/argp.h	Sat Jul  6 17:12:56 1996
+++ hurd-0.1/include/argp.h	Tue Sep  3 10:21:04 1996
@@ -258,6 +258,8 @@
 error_t argp_parse (const struct argp *argp,
 		    int argc, char **argv, unsigned flags,
 		    int *arg_index, void *input);
+
+/* Global variables.  */
 
 /* If defined or set by the user program to a non-zero value, then a default
    option --version is added (unless the ARGP_NO_HELP flag is used), which
@@ -272,16 +274,27 @@
    used).  This variable takes precedent over ARGP_PROGRAM_VERSION.  */
 extern void (*argp_program_version_hook) (FILE *stream,
 					  struct argp_state *state);
+
+/* If defined or set by the user program, it should point to string that is
+   the bug-reporting address for the program.  It will be printed by
+   argp_help if the ARGP_HELP_BUG_ADDR flag is set (as it is by various
+   standard help messages), embedded in a sentence that says something like
+   `Report bugs to ADDR.'.  */
+extern char *argp_program_bug_address;
 
 /* Flags for argp_help.  */
-#define ARGP_HELP_USAGE		0x01 /* Print a Usage: message. */
+#define ARGP_HELP_USAGE		0x01 /* a Usage: message. */
 #define ARGP_HELP_SHORT_USAGE	0x02 /*  " but don't actually print options. */
-#define ARGP_HELP_SEE		0x04 /* Print a `for more help...' message. */
-#define ARGP_HELP_LONG		0x08 /* Print a long help message. */
+#define ARGP_HELP_SEE		0x04 /* a `Try ... for more help' message. */
+#define ARGP_HELP_LONG		0x08 /* a long help message. */
+#define ARGP_HELP_PRE_DOC	0x10 /* doc string preceding long help.  */
+#define ARGP_HELP_POST_DOC	0x20 /* doc string following long help.  */
+#define ARGP_HELP_DOC		(ARGP_HELP_PRE_DOC | ARGP_HELP_POST_DOC)
+#define ARGP_HELP_BUG_ADDR	0x40 /* bug report address */
 
 /* These ARGP_HELP flags are only understood by argp_state_help.  */
-#define ARGP_HELP_EXIT_ERR	0x10 /* Call exit(1) instead of returning.  */
-#define ARGP_HELP_EXIT_OK	0x20 /* Call exit(0) instead of returning.  */
+#define ARGP_HELP_EXIT_ERR	0x100 /* Call exit(1) instead of returning.  */
+#define ARGP_HELP_EXIT_OK	0x200 /* Call exit(0) instead of returning.  */
 
 /* The standard thing to do after a program command line parsing error, if an
    error message has already been printed.  */
@@ -293,7 +306,8 @@
   (ARGP_HELP_SHORT_USAGE | ARGP_HELP_SEE | ARGP_HELP_EXIT_ERR)
 /* The standard thing to do in response to a --help option.  */
 #define ARGP_HELP_STD_HELP \
-  (ARGP_HELP_SHORT_USAGE | ARGP_HELP_LONG | ARGP_HELP_EXIT_OK)
+  (ARGP_HELP_SHORT_USAGE | ARGP_HELP_LONG | ARGP_HELP_EXIT_OK \
+   | ARGP_HELP_DOC | ARGP_HELP_BUG_ADDR)
 
 /* Output a usage message for ARGP to STREAM.  FLAGS are from the set
    ARGP_HELP_*.  */
diff -ru hurd-0.0/init/ChangeLog hurd-0.1/init/ChangeLog
--- hurd-0.0/init/ChangeLog	Wed Jul 17 18:54:50 1996
+++ hurd-0.1/init/ChangeLog	Thu Sep  5 11:13:22 1996
@@ -1,3 +1,37 @@
+Thu Sep  5 11:12:32 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* init.c: Include <version.h>.
+	(init_version): Delete variable.
+	(launch_core_servers): Pass empty string as release; HURD_VERSION
+	as version.
+
+Tue Aug 13 17:51:38 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* Makefile (init): Remove -lutil.
+	(libutil-libsubst): Variable removed.
+	(LDLIBS): New variable.
+
+Mon Aug 12 11:12:22 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* init.c (setup_terminal): Declare LINE.
+	(add_terminal): Don't declare LINE.
+
+Thu Aug  8 16:34:06 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* init.c (setup_terminal): New function.
+	(add_terminal): Use setup_terminal.
+	(reread_ttys): When turning an existent terminal spec on, call
+	setup_terminal before startup_terminal.
+
+	* init.c (struct terminal): New member `read'.
+	(shutdown_terminal): New function.
+	(reread_ttys): Use shutdown_terminal instead of doing it by hand.
+	Keep track of which ttys we used to know about are no longer in
+	/etc/ttys, and treat them as now `off'.
+	
+	* init.c (kill_everyone): `continue' in the essential task case
+	didn't go back to the main loop; fix it up correctly.
+
 Tue Jul 16 11:55:09 1996  Michael I. Bushnell, p/BSG  <mib@gnu.ai.mit.edu>
 
 	* init.c (process_signal): Set WUNTRACED in call to waitpid.
diff -ru hurd-0.0/init/Makefile hurd-0.1/init/Makefile
--- hurd-0.0/init/Makefile	Wed Jul  3 15:06:30 1996
+++ hurd-0.1/init/Makefile	Wed Aug 14 14:04:48 1996
@@ -22,9 +22,10 @@
 OBJS = init.o startupServer.o notifyServer.o startup_replyUser.o msgServer.o \
 	startup_notifyUser.o
 target = init
-libutil-libsubst = -lutil
 
-init: $(OBJS) ../libports/libports.a ../libfshelp/libfshelp.a ../libshouldbeinlibc/libshouldbeinlibc.a -lutil
+LDLIBS=-lutil
+
+init: $(OBJS) ../libports/libports.a ../libfshelp/libfshelp.a ../libshouldbeinlibc/libshouldbeinlibc.a
 
 mung_msg_S.h: msg_S.h
 	sed 's/msg_server/mung_msg_server/' < $< > $@
diff -ru hurd-0.0/init/init.c hurd-0.1/init/init.c
--- hurd-0.0/init/init.c	Tue Jul 16 11:54:58 1996
+++ hurd-0.1/init/init.c	Thu Sep  5 11:13:25 1996
@@ -49,6 +49,7 @@
 #include <argz.h>
 #include <utmp.h>
 #include <maptime.h>
+#include <version.h>
 
 #include "startup_notify_U.h"
 #include "startup_reply_U.h"
@@ -113,6 +114,7 @@
   
   int on;
   int pid;
+  int read;
   
   char *name;
 };
@@ -154,8 +156,6 @@
 /* The tasks of auth and proc and the bootstrap filesystem. */
 task_t authtask, proctask, fstask;
 
-char *init_version = "0.0";
-
 mach_port_t default_ports[INIT_PORT_MAX];
 mach_port_t default_dtable[3];
 int default_ints[INIT_INT_MAX];
@@ -474,13 +474,38 @@
 
 /** /etc/ttys support **/
 
+/* Set up the getty and window fields of terminal spec T corresponding
+   to line TT. */
+void
+setup_terminal (struct terminal *t, struct ttyent *tt)
+{
+  char *line;
+
+  if (t->getty_argz)
+    free (t->getty_argz);
+  if (t->window_argz)
+    free (t->window_argz);
+
+  if ((tt->ty_status & TTY_ON) && tt->ty_getty)
+    {
+      asprintf (&line, "%s %s", tt->ty_getty, tt->ty_name);
+      argz_create_sep (line, ' ', &t->getty_argz, &t->getty_argz_len);
+      if (tt->ty_window)
+	argz_create_sep (tt->ty_window, ' ', 
+			 &t->window_argz, &t->window_argz_len);
+      else
+	t->window_argz = 0;
+    }
+  else
+      t->getty_argz = t->window_argz = 0;
+}  
+
 
 /* Add a new terminal spec for TT and return it. */
 struct terminal *
 add_terminal (struct ttyent *tt)
 {
   struct terminal *t;
-  char *line;
   
   if (nttys >= ttyslen)
     {
@@ -495,30 +520,12 @@
   t->name = malloc (strlen (tt->ty_name) + 1);
   strcpy (t->name, tt->ty_name);
 
+  setup_terminal (t, tt);
   if (t->getty_argz)
-    free (t->getty_argz);
-  if (t->window_argz)
-    free (t->window_argz);
+    t->on = 1;
 
-  if ((tt->ty_status & TTY_ON) && tt->ty_getty)
-    {
-      asprintf (&line, "%s %s", tt->ty_getty, tt->ty_name);
-      argz_create_sep (line, ' ', &t->getty_argz, &t->getty_argz_len);
-      if (tt->ty_window)
-	argz_create_sep (tt->ty_window, ' ', 
-			 &t->window_argz, &t->window_argz_len);
-      else
-	t->window_argz = 0;
-      t->on = 1;
-    }
-  else
-    {
-      t->getty_argz = t->window_argz = 0;
-      t->on = 0;
-    }
   return t;
 }
-  
 
 /* Read /etc/ttys and initialize ttys array.  Return non-zero if we fail. */
 int
@@ -649,22 +656,34 @@
       }
 }  
 
+/* Shutdown the things running on terminal spec T. */
+void
+shutdown_terminal (struct terminal *t)
+{
+  kill (t->pid, SIGHUP);
+  /* revoke?? */;
+}
+
 /* Re-read /etc/ttys.  If a line has turned off, kill what's there.
-   If a line has turned on, start it.  If an on line has changed,
-   kill it, and then restart it. */
+   If a line has turned on, start it.  */
 void
 reread_ttys (void)
 {
   struct ttyent *tt;
   struct terminal *t;
   int on;
-
+  int i;
+  
   if (!setttyent ())
     {
       error (0, errno, "%s", _PATH_TTYS);
       return;
     }
   
+  /* Mark all the lines not yet read */
+  for (i = 0; i < nttys; i++)
+    ttys[i].read = 0;
+
   while ((tt = getttyent ()))
     {
       if (!tt->ty_name)
@@ -678,11 +697,12 @@
 	  if (t->on && !on)
 	    {
 	      t->on = 0;
-	      kill (t->pid, SIGHUP);
+	      shutdown_terminal (t);
 	    }
 	  else if (!t->on && on)
 	    {
 	      t->on = 1;
+	      setup_terminal (t, tt);
 	      startup_terminal (t);
 	    }
 	}
@@ -692,8 +712,18 @@
 	  if (on)
 	    startup_terminal (t);
 	}
+
+      t->read = 1;
     }
   endttyent ();
+
+  /* Scan tty entries; any that were not found and were on, turn off. */
+  for (i = 0; i < nttys; i++)
+    if (!ttys[i].read && ttys[i].on)
+      {
+	ttys[i].on = 0;
+	shutdown_terminal (&ttys[i]);
+      }
 }
 
 
@@ -848,8 +878,7 @@
 
   default_ports[INIT_PORT_AUTH] = authserver;
 
-  proc_register_version (procserver, host_priv, "init", HURD_RELEASE,
-			 init_version);
+  proc_register_version (procserver, host_priv, "init", "", HURD_VERSION);
 
   /* Get the bootstrap filesystem's proc server port.
      We must do this before calling proc_setmsgport below.  */
@@ -1213,8 +1242,10 @@
 		  {
 		    /* Skip this one */
 		    mach_port_deallocate (mach_task_self (), tk);
-		    continue;
+		    break;
 		  }
+	      if (es)
+		continue;
 	      
 	      /* Kill it */
 	      if (signo == SIGKILL)
diff -ru hurd-0.0/libdiskfs/ChangeLog hurd-0.1/libdiskfs/ChangeLog
--- hurd-0.0/libdiskfs/ChangeLog	Thu Aug  1 17:25:40 1996
+++ hurd-0.1/libdiskfs/ChangeLog	Thu Sep  5 18:39:27 1996
@@ -1,3 +1,109 @@
+Thu Sep  5 11:13:54 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* io-version.c (diskfs_S_io_server_version): Only fill in
+	SERVER_NAME; ignore the rest.
+
+	* diskfs.h (diskfs_major_version, diskfs_minor_version,
+	diskfs_edit_version): Delete variables.
+	(diskfs_server_version, diskfs_extra_version): New variables.
+	* boot-start.c (diskfs_S_fsys_init): Register version from
+	diskfs_server_version; pass empty string as release.
+	* extra-version.c: New file.
+	* Makefile (OTHERSRCS): Add extra-version.c.
+	* opts-version.c: Include <version.h>.
+ 	(diskfs_extra_version): Delete special declaration. 
+	(_print_version): Use the user's provided version number, and also
+	give it our (libdiskfs) version number.
+
+Tue Sep  3 10:48:05 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* name-cache.c (diskfs_enter_lookup_cache): Cache `.' and `..'
+	just like other nodes.
+	(diskfs_check_lookup_cache): If we get a cache hit on `..', then
+	do the inverse locking semantic, and only return success if things
+	are stable around the call.
+
+Fri Aug 30 21:57:18 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* lookup.c (cache_misses): New variable, to find out what sort of
+	thing all the cache misses are.
+	(cm_lock): New variable.
+	(diskfs_lookup): Keep track of cache misses in cache_misses.
+
+	* name-cache.c (MAXCACHE): 200 now.  After experimentation, this
+	appears to be a pretty good value.  Very little benefit after
+	this. 
+
+Fri Aug 30 20:41:27 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* name-cache.c (struct lookup_cache): Delete member `hits'.
+	New member `stati'.
+	(diskfs_enter_lookup_cache): Don't initialize C->hits.
+	(find_cache): Set C->stati before returning.
+	(build_partial): Delete function.
+	(diskfs_check_lookup_cache): Delete calls to build_partial.
+	Register all statistics through register_neg_hit,
+	register_pos_hit, and register_miss.
+	(MAXCACHE): 2000 now.
+
+Wed Aug 28 12:20:53 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* name-cache.c (MAXCACHE): 500 for now.
+
+Mon Aug 26 15:10:55 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* name-cache.c (MAXCACHE): Increase to 50000.
+	(struct lookup_cache): New member `hits'.
+	(statistics): Name struct type `struct stats'.
+	(diskfs_enter_lookup_cache): Initialize C->hits.
+	(PARTIAL_THRESH, NPARTIALS): New macros.
+	(partial_stats): New variable.
+	(build_partial): New function.
+	(diskfs_check_lookup_cache): Call build_partial after statistics
+	frobbing. 
+
+	* name-cache.c (diskfs_check_lookup_cache): Increment members of
+	statistics while still holding CACHE_LOCK.
+
+Fri Aug 16 18:23:25 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* name-cache.c (diskfs_check_lookup_cache): Keep track of negative
+	hits properly.
+	* lookup.c (diskfs_lookup): On LOOKUPs that fail to find the node,
+	enter a negative cache entry.
+
+Thu Aug 15 16:07:23 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* opts-version.c (diskfs_extra_version): New (weak) reference.
+	(_print_version): Use DISKFS_EXTRA_VERSION.  Tweak edit version.
+	Fix type of EV.
+
+Thu Aug 15 16:38:41 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* io-identity.c (diskfs_S_io_identity): Don't hold lock around
+	call to fshelp_get_identity.
+
+Mon Aug 12 15:54:27 1996  Miles Bader  <miles@gnu.ai.mit.edu>
+
+	* opts-version.c (_print_version): Print the edit version too if
+	it's non-zero.
+
+Thu Aug  8 18:18:09 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* readonly.c: Include <error.h>.
+
+Wed Aug  7 13:53:56 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
+
+	* readonly.c (diskfs_check_readonly): If we get an error from
+	diskfs_hypermetadata, then switch to readonly.
+	* diskfs.h (diskfs_set_hypermetadata): Require an error code return.
+	* dev-io.c (diskfs_device_write_sync): If we get D_READ_ONLY, then
+	return EROFS to the caller instead of EIO.
+
+	* node-create.c (diskfs_create_node): New files always copy GID
+	from their parent; that's NetBSD's behavior, and it's good enough
+	for me. 
+
 Thu Aug  1 17:24:08 1996  Thomas Bushnell, n/BSG  <thomas@gnu.ai.mit.edu>
 
 	* file-get-transcntl.c (diskfs_S_file_get_translator_cntl): Don't
diff -ru hurd-0.0/libdiskfs/Makefile hurd-0.1/libdiskfs/Makefile
--- hurd-0.0/libdiskfs/Makefile	Sat Jul  6 17:14:14 1996
+++ hurd-0.1/libdiskfs/Makefile	Thu Sep  5 11:18:20 1996
@@ -48,7 +48,7 @@
 	dev-open.c dev-io.c dev-globals.c console.c disk-pager.c \
 	name-cache.c direnter.c dirrewrite.c dirremove.c lookup.c dead-name.c \
 	validate-mode.c validate-group.c validate-author.c validate-flags.c \
-	validate-rdev.c validate-owner.c
+	validate-rdev.c validate-owner.c extra-version.c
 SRCS = $(OTHERSRCS) $(FSSRCS) $(IOSRCS) $(FSYSSRCS) $(IFSOCKSRCS)
 LCLHDRS = diskfs.h priv.h lithp.h fsmutations.h diskfs-pager.h
 installhdrs = diskfs.h diskfs-pager.h
diff -ru hurd-0.0/libdiskfs/boot-start.c hurd-0.1/libdiskfs/boot-start.c
--- hurd-0.0/libdiskfs/boot-start.c	Sun Jul  7 21:21:04 1996
+++ hurd-0.1/libdiskfs/boot-start.c	Thu Sep  5 12:53:07 1996
@@ -366,7 +366,6 @@
   struct port_infe *pt;
   static int initdone = 0;
   process_t execprocess;
-  string_t version;
   mach_port_t host, startup;
   error_t err;
   mach_port_t root_pt;
@@ -463,9 +462,8 @@
   if (err)
     return err;
 
-  sprintf (version, "%d.%d", diskfs_major_version, diskfs_minor_version);
-  proc_register_version (procserver, host,
-			 diskfs_server_name, HURD_RELEASE, version);
+  proc_register_version (procserver, host, diskfs_server_name, "", 
+			 diskfs_server_version);
 
   err = proc_getmsgport (procserver, 1, &startup);
   if (!err)
diff -ru hurd-0.0/libdiskfs/dev-io.c hurd-0.1/libdiskfs/dev-io.c
--- hurd-0.0/libdiskfs/dev-io.c	Fri Oct 13 19:14:47 1995
+++ hurd-0.1/libdiskfs/dev-io.c	Wed Aug  7 15:12:28 1996
@@ -1,5 +1,5 @@
 /* Device input and output
-   Copyright (C) 1992, 1993, 1994, 1995 Free Software Foundation, Inc.
+   Copyright (C) 1992, 1993, 1994, 1995, 1996 Free Software Foundation, Inc.
 
 This file is part of the GNU Hurd.
 
@@ -29,10 +29,15 @@
 diskfs_device_write_sync (off_t addr, vm_address_t data, size_t len)
 {
   int written;
+  error_t err;
+  
   assert (!diskfs_readonly);
-  if (device_write (diskfs_device, 0, diskfs_device_start + addr,
-		    (io_buf_ptr_t) data, len, &written)
-      || written != len)
+  err = device_write (diskfs_device, 0, diskfs_device_start + addr,
+		      (io_buf_ptr_t) data, len, &written);
+  
+  if (err == D_READ_ONLY)
+    return EROFS;
+  else if (err || written != len)
     return EIO;
   return 0;
 }
diff -ru hurd-0.0/libdiskfs/diskfs.h hurd-0.1/libdiskfs/diskfs.h
--- hurd-0.0/libdiskfs/diskfs.h	Mon Jul 15 22:35:45 1996
+++ hurd-0.1/libdiskfs/diskfs.h	Thu Sep  5 11:16:56 1996
@@ -203,11 +203,13 @@
    filesystem server. */
 extern char *diskfs_server_name;
 
-/* The user must define these variables.  Set these to be the major, minor,
-   and edit version numbers.  */
-extern int diskfs_major_version;
-extern int diskfs_minor_version;
-extern int diskfs_edit_version;
+/* The user must define this variables.  Set this to be the server
+   version number.  */
+extern char *diskfs_server_version;
+
+/* The user may define this variable.  Set this to be any additional
+   version specification that should be printed for --version. */
+extern char *diskfs_extra_version;
 
 /* The user may define this variable.  This should be nonzero iff the
    filesystem format supports shortcutting symlink translation.
@@ -364,7 +366,7 @@
    metadata.  If CLEAN is nonzero, then after this is written the
    filesystem will be absolutely clean, and the non-paged metadata can
    so indicate.  */
-void diskfs_set_hypermetadata (int wait, int clean);
+error_t diskfs_set_hypermetadata (int wait, int clean);
 
 /* The user must define this function.  Allocate a new node to be of
    mode MODE in locked directory DP (don't actually set the mode or
Only in hurd-0.1/libdiskfs: extra-version.c
diff -ru hurd-0.0/libdiskfs/io-identity.c hurd-0.1/libdiskfs/io-identity.c
--- hurd-0.0/libdiskfs/io-identity.c	Wed Jul  3 11:37:25 1996
+++ hurd-0.1/libdiskfs/io-identity.c	Thu Aug 15 16:38:03 1996
@@ -32,14 +32,17 @@
 {
   struct node *np;
   error_t err;
+  ino_t inum;
 
   if (!cred)
     return EOPNOTSUPP;
   
   np = cred->po->np;
   mutex_lock (&np->lock);
-  
-  err = fshelp_get_identity (diskfs_port_bucket, np->dn_stat.st_ino, id);
+  inum = np->dn_stat.st_ino;
+  mutex_unlock (&np->lock);
+
+  err = fshelp_get_identity (diskfs_port_bucket, inum, id);
   if (!err)
     {
       *idtype = MACH_MSG_TYPE_MAKE_SEND;
diff -ru hurd-0.0/libdiskfs/io-version.c hurd-0.1/libdiskfs/io-version.c
--- hurd-0.0/libdiskfs/io-version.c	Thu May  5 09:13:53 1994
+++ hurd-0.1/libdiskfs/io-version.c	Thu Sep  5 12:00:43 1996
@@ -1,5 +1,5 @@
 /*
-   Copyright (C) 1994 Free Software Foundation
+   Copyright (C) 1994, 1996 Free Software Foundation
 
 This file is part of the GNU Hurd.
 
@@ -31,10 +31,8 @@
 {
   if (cred)
     {
-      strcpy (server_name, diskfs_server_name);
-      *major = diskfs_major_version;
-      *minor = diskfs_minor_version;
-      *edit = diskfs_edit_version;
+      sprintf (server_name, "%s %s", 
+	       diskfs_server_name, diskfs_server_version);
       return 0;
     }
   else
diff -ru hurd-0.0/libdiskfs/lookup.c hurd-0.1/libdiskfs/lookup.c
--- hurd-0.0/libdiskfs/lookup.c	Mon Jul 29 12:33:26 1996
+++ hurd-0.1/libdiskfs/lookup.c	Fri Aug 30 23:24:14 1996
@@ -20,6 +20,17 @@
 
 #include "priv.h"
 
+static struct
+{
+  int present;
+  int absent;
+  int errors;
+  int dot;
+  int dotdot;
+} cache_misses;
+static spin_lock_t cm_lock = SPIN_LOCK_INITIALIZER;
+
+
 /* Lookup in directory DP (which is locked) the name NAME.  TYPE will
    either be LOOKUP, CREATE, RENAME, or REMOVE.  CRED identifies the
    user making the call.
@@ -71,7 +82,7 @@
 	       struct protid *cred)
 {
   error_t err;
-  
+
   if (type == REMOVE || type == RENAME)
     assert (np);
 
@@ -119,6 +130,26 @@
     }
   
   err = diskfs_lookup_hard (dp, name, type, np, ds, cred);
+
+  spin_lock (&cm_lock);
+  if (type == LOOKUP)
+    {
+      if (err == ENOENT)
+	cache_misses.absent++;
+      else if (err)
+	cache_misses.errors++;
+      else 
+	cache_misses.present++;
+      if (name[0] == '.')
+	{
+	  if (name[1] == '\0')
+	    cache_misses.dot++;
+	  else if (name[1] == '.' && name[2] == '\0')
+	    cache_misses.dotdot++;
+	}
+    }
+  spin_unlock (&cm_lock);
+
   if (err && err != ENOENT)
     return err;
   
@@ -137,6 +168,8 @@
 
   if ((type == LOOKUP || type == CREATE) && !err && np)
     diskfs_enter_lookup_cache (dp, *np, name);
+  else if (type == LOOKUP && err == ENOENT)
+    diskfs_enter_lookup_cache (dp, 0, name);
     
   return err;
 }
diff -ru hurd-0.0/libdiskfs/name-cache.c hurd-0.1/libdiskfs/name-cache.c
--- hurd-0.0/libdiskfs/name-cache.c	Mon Apr 29 16:11:08 1996
+++ hurd-0.1/libdiskfs/name-cache.c	Tue Sep  3 11:36:42 1996
@@ -24,7 +24,7 @@
 #include <cacheq.h>
 
 /* Maximum number of names to cache at once */
-#define MAXCACHE 256
+#define MAXCACHE 200
 
 /* Maximum length of file name we bother caching */
 #define CACHE_NAME_LEN 100
@@ -44,7 +44,10 @@
   char name[CACHE_NAME_LEN];
 
   /* Strlen of NAME.  If this is zero, it's an unused entry. */
-  size_t name_len;		
+  size_t name_len;
+
+  /* XXX */
+  int stati;
 };
 
 /* The contents of the cache in no particular order */
@@ -53,13 +56,18 @@
 static spin_lock_t cache_lock = SPIN_LOCK_INITIALIZER;
 
 /* Buffer to hold statistics */
-static struct
+static struct stats
 {
   long pos_hits;
   long neg_hits;
   long miss;
   long fetch_errors;
 } statistics;
+
+#define PARTIAL_THRESH 100
+#define NPARTIALS MAXCACHE / PARTIAL_THRESH
+struct stats partial_stats [NPARTIALS];
+
 
 /* If there's an entry for NAME, of length NAME_LEN, in directory DIR in the
    cache, return it's entry, otherwise 0.  CACHE_LOCK must be held.  */
@@ -67,15 +75,21 @@
 find_cache (struct node *dir, const char *name, size_t name_len)
 {
   struct lookup_cache *c;
+  int i;
 
   /* Search the list.  All unused entries are contiguous at the end of the
      list, so we can stop searching when we see the first one.  */
-  for (c = lookup_cache.mru; c && c->name_len; c = c->hdr.next)
+  for (i = 0, c = lookup_cache.mru; 
+       c && c->name_len; 
+       c = c->hdr.next, i++)
     if (c->name_len == name_len
 	&& c->dir_cache_id == dir->cache_id
 	&& c->name[0] == name[0] && strcmp (c->name, name) == 0)
-      return c;
-
+      {
+	c->stati = i / 100;
+	return c;
+      }
+  
   return 0;
 }
 
@@ -90,13 +104,6 @@
   if (name_len > CACHE_NAME_LEN - 1)
     return;
 
-  /* Never cache . or ..; it's too much trouble to get the locking
-     order right.  */
-  if (name[0] == '.' 
-      && (name[1] == '\0'
-	  || (name[1] == '.' && name[2] == '\0')))
-    return;
-
   spin_lock (&cache_lock);
 
   if (lookup_cache.length == 0)
@@ -145,6 +152,47 @@
   spin_unlock (&cache_lock);
 }
 
+/* Register a negative hit for an entry in the Nth stat class */
+void
+register_neg_hit (int n)
+{
+  int i;
+
+  statistics.neg_hits++;
+
+  for (i = 0; i < n; i++)
+    partial_stats[i].miss++;
+  for (; i < NPARTIALS; i++)
+    partial_stats[i].neg_hits++;
+}
+
+/* Register a positive hit for an entry in the Nth stat class */
+void
+register_pos_hit (int n)
+{
+  int i;
+
+  statistics.pos_hits++;
+
+  for (i = 0; i < n; i++)
+    partial_stats[i].miss++;
+  for (; i < NPARTIALS; i++)
+    partial_stats[i].pos_hits++;
+}
+  
+/* Register a miss */
+void
+register_miss ()
+{
+  int i;
+  
+  statistics.miss++;
+  for (i = 0; i < NPARTIALS; i++)
+    partial_stats[i].miss++;
+}
+
+
+
 /* Scan the cache looking for NAME inside DIR.  If we don't know
    anything entry at all, then return 0.  If the entry is confirmed to
    not exist, then return -1.  Otherwise, return NP for the entry, with
@@ -163,15 +211,18 @@
 
       cacheq_make_mru (&lookup_cache, c); /* Record C as recently used.  */
 
-      statistics.pos_hits++;
-      spin_unlock (&cache_lock);
-
       if (id == 0)
 	/* A negative cache entry.  */
-	return (struct node *)-1;
+	{
+	  register_neg_hit (c->stati);
+	  spin_unlock (&cache_lock);
+	  return (struct node *)-1;
+	}
       else if (id == dir->cache_id)
 	/* The cached node is the same as DIR.  */
 	{
+	  register_pos_hit (c->stati);
+	  spin_unlock (&cache_lock);
 	  diskfs_nref (dir);
 	  return dir;
 	}
@@ -179,12 +230,35 @@
 	/* Just a normal entry in DIR; get the actual node.  */
 	{
 	  struct node *np;
-	  error_t err = diskfs_cached_lookup (id, &np);
+	  error_t err;
+	  
+	  register_pos_hit (c->stati);
+	  spin_unlock (&cache_lock);
+	  
+	  if (name[0] == '.' && name[1] == '.' && name[2] == '\0')
+	    {
+	      mutex_unlock (&dir->lock);
+	      err = diskfs_cached_lookup (id, &np);
+	      mutex_lock (&dir->lock);
+
+	      /* In the window where DP was unlocked, we might
+		 have lost.  So check the cache again, and see
+		 if it's still there; if so, then we win. */
+	      c = find_cache (dir, "..", 2);
+	      if (!c || c->node_cache_id != id)
+		{
+		  /* Lose */
+		  mutex_unlock (&np->lock);
+		  return 0;
+		}
+	    }
+	  else
+	    err = diskfs_cached_lookup (id, &np);
 	  return err ? 0 : np;
 	}
     }
   
-  statistics.miss++;
+  register_miss ();
   spin_unlock (&cache_lock);
 
   return 0;
diff -ru hurd-0.0/libdiskfs/node-create.c hurd-0.1/libdiskfs/node-create.c
--- hurd-0.0/libdiskfs/node-create.c	Mon Jun 24 16:45:19 1996
+++ hurd-0.1/libdiskfs/node-create.c	Wed Aug  7 13:53:43 1996
@@ -64,15 +64,9 @@
     goto change_err;
   np->dn_stat.st_uid = newuid;
 
-  if (diskfs_groupmember (dir->dn_stat.st_gid, cred))
-    newgid = dir->dn_stat.st_gid;
-  else if (cred->ngids)
-    newgid = cred->gids[0];
-  else
-    {
-      newgid = dir->dn_stat.st_gid;
-      mode &= ~S_ISGID;
-    }
+  newgid = dir->dn_stat.st_gid;
+  if (!diskfs_groupmember (newgid, cred))
+    mode &= ~S_ISGID;
   err = diskfs_validate_group_change (np, newgid);
   if (err)
     goto change_err;
